Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -1731,6 +1707,6 @@
                      CALL flush(numout)
 #   endif
-                  CALL gas_transfer( f_wind, 1, 7, &  ! inputs
-                                     f_kw660 )        ! outputs
+                  CALL gas_transfer( wndm(ji,jj), 1, 7, &  ! inputs
+                                     f_kw660(ji,jj) )        ! outputs
 #   if defined key_debug_medusa
                      IF (lwp) write (numout,*) 'trc_bio_medusa: exiting gas_transfer'
@@ -1741,10 +1717,10 @@
                   !! of the UKESM1 atmosphere 
                   !!                                     
-                  f_pp0   = 1.0
-                  !!
-                  !! IF(lwp) WRITE(numout,*) ' MEDUSA ztmp    =', ztmp
+                  f_pp0(ji,jj)   = 1.0
+                  !!
+                  !! IF(lwp) WRITE(numout,*) ' MEDUSA ztmp    =', ztmp(ji,jj)
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA zwind_i =', zwind_i(ji,jj)
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA zwind_j =', zwind_j(ji,jj)
-                  !! IF(lwp) WRITE(numout,*) ' MEDUSA f_wind  =', f_wind
+                  !! IF(lwp) WRITE(numout,*) ' MEDUSA wndm    =', wndm(ji,jj)
                   !! IF(lwp) WRITE(numout,*) ' MEDUSA fr_i    =', fr_i(ji,jj)
                   !!
@@ -1755,21 +1731,21 @@
                   !!                 chemistry package; note that depth is set to
                   !!                 zero in this call
-                  CALL mocsy_interface( ztmp, zsal, zalk, zdic, zsil, zpho,        &  ! inputs
-                  f_pp0, 0.0, gphit(ji,jj), f_kw660, f_xco2a, 1,                   &  ! inputs
-                  f_ph, f_pco2w, f_fco2w, f_h2co3, f_hco3, f_co3, f_omarg(ji,jj),  &  ! outputs
-                  f_omcal(ji,jj), f_BetaD, f_rhosw, f_opres, f_insitut,            &  ! outputs
-                  f_pco2atm, f_fco2atm, f_schmidtco2, f_kwco2, f_K0,               &  ! outputs
-                  f_co2starair, f_co2flux, f_dpco2 )                                  ! outputs
-                  !!
-                  f_TDIC = (zdic / f_rhosw) * 1000. ! mmol / m3 -> umol / kg
-                  f_TALK = (zalk / f_rhosw) * 1000. !  meq / m3 ->  ueq / kg
-                  f_dcf  = f_rhosw
+                  CALL mocsy_interface( ztmp(ji,jj), zsal(ji,jj), zalk(ji,jj), zdic(ji,jj), zsil(ji,jj), zpho(ji,jj),        &  ! inputs
+                  f_pp0(ji,jj), 0.0, gphit(ji,jj), f_kw660(ji,jj), f_xco2a, 1,                   &  ! inputs
+                  f_ph(ji,jj), f_pco2w(ji,jj), f_fco2w(ji,jj), f_h2co3(ji,jj), f_hco3(ji,jj), f_co3(ji,jj), f_omarg(ji,jj),  &  ! outputs
+                  f_omcal(ji,jj), f_BetaD(ji,jj), f_rhosw(ji,jj), f_opres(ji,jj), f_insitut(ji,jj),            &  ! outputs
+                  f_pco2atm(ji,jj), f_fco2atm(ji,jj), f_schmidtco2(ji,jj), f_kwco2(ji,jj), f_K0(ji,jj),               &  ! outputs
+                  f_co2starair(ji,jj), f_co2flux(ji,jj), f_dpco2(ji,jj) )                                  ! outputs
+                  !!
+                  f_TDIC(ji,jj) = (zdic(ji,jj) / f_rhosw(ji,jj)) * 1000. ! mmol / m3 -> umol / kg
+                  f_TALK(ji,jj) = (zalk(ji,jj) / f_rhosw(ji,jj)) * 1000. !  meq / m3 ->  ueq / kg
+                  f_dcf(ji,jj)  = f_rhosw(ji,jj)
 #   else                  
-                  iters = 0
+                  iters(ji,jj) = 0
                   !!
                   !! carbon dioxide (CO2); Jerry Blackford code (ostensibly OCMIP-2, but not)
-                  CALL trc_co2_medusa( ztmp, zsal, zdic, zalk, 0.0, f_kw660, f_xco2a,  &  ! inputs
-                  f_ph, f_pco2w, f_h2co3, f_hco3, f_co3, f_omcal(ji,jj),               &  ! outputs
-                  f_omarg(ji,jj), f_co2flux, f_TDIC, f_TALK, f_dcf, f_henry, iters )      ! outputs
+                  CALL trc_co2_medusa( ztmp(ji,jj), zsal(ji,jj), zdic(ji,jj), zalk(ji,jj), 0.0, f_kw660(ji,jj), f_xco2a,  &  ! inputs
+                  f_ph(ji,jj), f_pco2w(ji,jj), f_h2co3(ji,jj), f_hco3(ji,jj), f_co3(ji,jj), f_omcal(ji,jj),               &  ! outputs
+                  f_omarg(ji,jj), f_co2flux(ji,jj), f_TDIC(ji,jj), f_TALK(ji,jj), f_dcf(ji,jj), f_henry(ji,jj), iters(ji,jj) )      ! outputs
                   !!
                   !! AXY (09/01/14): removed iteration and NaN checks; these have
@@ -1779,7 +1755,7 @@
                   !!                 output warnings are retained here so that
                   !!                 failure position can be determined
-                  if (iters .eq. 25) then
+                  if (iters(ji,jj) .eq. 25) then
                      IF(lwp) WRITE(numout,*) ' trc_bio_medusa: ITERS WARNING, ', &
-                     iters, ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
+                     iters(ji,jj), ' AT (', ji, ', ', jj, ', ', jk, ') AT ', kt
                   endif
 #   endif
@@ -1787,44 +1763,44 @@
                   !! AXY (18/04/13): switch off carbonate chemistry calculations; provide
                   !!                 quasi-sensible alternatives
-                  f_ph           = 8.1
-                  f_pco2w        = f_xco2a
-                  f_h2co3        = 0.005 * zdic
-                  f_hco3         = 0.865 * zdic
-                  f_co3          = 0.130 * zdic
+                  f_ph(ji,jj)           = 8.1
+                  f_pco2w(ji,jj)        = f_xco2a
+                  f_h2co3(ji,jj)        = 0.005 * zdic(ji,jj)
+                  f_hco3(ji,jj)         = 0.865 * zdic(ji,jj)
+                  f_co3(ji,jj)          = 0.130 * zdic(ji,jj)
                   f_omcal(ji,jj) = 4.
                   f_omarg(ji,jj) = 2.
-                  f_co2flux      = 0.
-                  f_TDIC         = zdic
-                  f_TALK         = zalk
-                  f_dcf          = 1.026
-                  f_henry        = 1.
+                  f_co2flux(ji,jj)      = 0.
+                  f_TDIC(ji,jj)         = zdic(ji,jj)
+                  f_TALK(ji,jj)         = zalk(ji,jj)
+                  f_dcf(ji,jj)          = 1.026
+                  f_henry(ji,jj)        = 1.
                   !! AXY (23/06/15): add in some extra MOCSY diagnostics
-                  f_fco2w        = f_xco2a
-                  f_BetaD        = 1.
-                  f_rhosw        = 1.026
-                  f_opres        = 0.
-                  f_insitut      = ztmp
-                  f_pco2atm      = f_xco2a
-                  f_fco2atm      = f_xco2a
-                  f_schmidtco2   = 660.
-                  f_kwco2        = 0.
-                  f_K0           = 0.
-                  f_co2starair   = f_xco2a
-                  f_dpco2        = 0.
+                  f_fco2w(ji,jj)        = f_xco2a
+                  f_BetaD(ji,jj)        = 1.
+                  f_rhosw(ji,jj)        = 1.026
+                  f_opres(ji,jj)        = 0.
+                  f_insitut(ji,jj)      = ztmp(ji,jj)
+                  f_pco2atm(ji,jj)      = f_xco2a
+                  f_fco2atm(ji,jj)      = f_xco2a
+                  f_schmidtco2(ji,jj)   = 660.
+                  f_kwco2(ji,jj)        = 0.
+                  f_K0(ji,jj)           = 0.
+                  f_co2starair(ji,jj)   = f_xco2a
+                  f_dpco2(ji,jj)        = 0.
 #  endif
                   !!
                   !! mmol/m2/s -> mmol/m3/d; correct for sea-ice; divide through by layer thickness
-                  f_co2flux = (1. - fr_i(ji,jj)) * f_co2flux * 86400. / fthk
+                  f_co2flux(ji,jj) = (1. - fr_i(ji,jj)) * f_co2flux(ji,jj) * 86400. / fse3t(ji,jj,jk)
                   !!
                   !! oxygen (O2); OCMIP-2 code
                   !! AXY (23/06/15): amend input list for oxygen to account for common gas
                   !!                 transfer velocity
-                  !! CALL trc_oxy_medusa( ztmp, zsal, f_uwind, f_vwind, f_pp0, zoxy / 1000., fthk,  &  ! inputs
-                  !! f_kw660, f_o2flux, f_o2sat )                                                      ! outputs
-                  CALL trc_oxy_medusa( ztmp, zsal, f_kw660, f_pp0, zoxy,  &  ! inputs
-                  f_kwo2, f_o2flux, f_o2sat )                                ! outputs
+                  !! Note that f_kwo2 is an about from the subroutine below,
+                  !! which doesn't seem to be used - marc 10/4/17 
+                  CALL trc_oxy_medusa( ztmp(ji,jj), zsal(ji,jj), f_kw660(ji,jj), f_pp0(ji,jj), zoxy(ji,jj),  &  ! inputs
+                  f_kwo2(ji,jj), f_o2flux(ji,jj), f_o2sat(ji,jj) )                                ! outputs
                   !!
                   !! mmol/m2/s -> mol/m3/d; correct for sea-ice; divide through by layer thickness
-                  f_o2flux  = (1. - fr_i(ji,jj)) * f_o2flux * 86400. / fthk
+                  f_o2flux(ji,jj)  = (1. - fr_i(ji,jj)) * f_o2flux(ji,jj) * 86400. / fse3t(ji,jj,jk)
                   !!
                   !! Jpalm (08-2014)
@@ -1846,22 +1822,22 @@
                      if (jdms_input .eq. 0) then
                         !! use instantaneous inputs
-                        CALL trc_dms_medusa( zchn, zchd, hmld(ji,jj), qsr(ji,jj), zdin, &  ! inputs
-                        dms_andr, dms_simo, dms_aran, dms_hall )                           ! outputs
+                        CALL trc_dms_medusa( zchn(ji,jj), zchd(ji,jj), hmld(ji,jj), qsr(ji,jj), zdin(ji,jj), &  ! inputs
+                        dms_andr(ji,jj), dms_simo(ji,jj), dms_aran(ji,jj), dms_hall(ji,jj) )                           ! outputs
                      else
                         !! use diel-average inputs
                         CALL trc_dms_medusa( zn_dms_chn(ji,jj), zn_dms_chd(ji,jj), &  ! inputs
                         zn_dms_mld(ji,jj), zn_dms_qsr(ji,jj), zn_dms_din(ji,jj),   &  ! inputs
-                        dms_andr, dms_simo, dms_aran, dms_hall )                      ! outputs
+                        dms_andr(ji,jj), dms_simo(ji,jj), dms_aran(ji,jj), dms_hall(ji,jj) )                      ! outputs
                      endif
                      !!
                      !! assign correct output to variable passed to atmosphere
                      if     (jdms_model .eq. 1) then
-                        dms_surf = dms_andr
+                        dms_surf(ji,jj) = dms_andr(ji,jj)
                      elseif (jdms_model .eq. 2) then
-                        dms_surf = dms_simo
+                        dms_surf(ji,jj) = dms_simo(ji,jj)
                      elseif (jdms_model .eq. 3) then
-                        dms_surf = dms_aran
+                        dms_surf(ji,jj) = dms_aran(ji,jj)
                      elseif (jdms_model .eq. 4) then
-                        dms_surf = dms_hall
+                        dms_surf(ji,jj) = dms_hall(ji,jj)
                      endif
                      !!
@@ -1869,17 +1845,17 @@
                      IF( lk_iomput ) THEN
                        IF( med_diag%DMS_SURF%dgsave ) THEN
-                         dms_surf2d(ji,jj) = dms_surf
+                         dms_surf2d(ji,jj) = dms_surf(ji,jj)
                        ENDIF
                        IF( med_diag%DMS_ANDR%dgsave ) THEN
-                         dms_andr2d(ji,jj) = dms_andr
+                         dms_andr2d(ji,jj) = dms_andr(ji,jj)
                        ENDIF
                        IF( med_diag%DMS_SIMO%dgsave ) THEN
-                         dms_simo2d(ji,jj) = dms_simo
+                         dms_simo2d(ji,jj) = dms_simo(ji,jj)
                        ENDIF
                        IF( med_diag%DMS_ARAN%dgsave ) THEN
-                         dms_aran2d(ji,jj) = dms_aran
+                         dms_aran2d(ji,jj) = dms_aran(ji,jj)
                        ENDIF
                        IF( med_diag%DMS_HALL%dgsave ) THEN
-                         dms_hall2d(ji,jj) = dms_hall
+                         dms_hall2d(ji,jj) = dms_hall(ji,jj)
                        ENDIF
 #   if defined key_debug_medusa
@@ -1898,33 +1874,33 @@
                   !! IF( med_diag%FGCO2%dgsave ) THEN
                      !! convert from  mol/m2/day to kg/m2/s
-                     fgco2(ji,jj) = f_co2flux * fthk * CO2flux_conv  !! mmol-C/m3/d -> kg-CO2/m2/s
+                     fgco2(ji,jj) = f_co2flux(ji,jj) * fse3t(ji,jj,jk) * CO2flux_conv  !! mmol-C/m3/d -> kg-CO2/m2/s
                   !! ENDIF
                   IF ( lk_iomput ) THEN
                       IF( med_diag%ATM_PCO2%dgsave ) THEN
-                         f_pco2a2d(ji,jj) = f_pco2atm
+                         f_pco2a2d(ji,jj) = f_pco2atm(ji,jj)
                       ENDIF
                       IF( med_diag%OCN_PCO2%dgsave ) THEN
-                         f_pco2w2d(ji,jj) = f_pco2w
+                         f_pco2w2d(ji,jj) = f_pco2w(ji,jj)
                       ENDIF
                       IF( med_diag%CO2FLUX%dgsave ) THEN
-                         f_co2flux2d(ji,jj) = f_co2flux * fthk           !! mmol/m3/d -> mmol/m2/d
+                         f_co2flux(ji,jj)2d(ji,jj) = f_co2flux(ji,jj) * fse3t(ji,jj,jk)           !! mmol/m3/d -> mmol/m2/d
                       ENDIF
                       IF( med_diag%TCO2%dgsave ) THEN
-                         f_TDIC2d(ji,jj) = f_TDIC
+                         f_TDIC2d(ji,jj) = f_TDIC(ji,jj)
                       ENDIF
                       IF( med_diag%TALK%dgsave ) THEN
-                         f_TALK2d(ji,jj) = f_TALK
+                         f_TALK2d(ji,jj) = f_TALK(ji,jj)
                       ENDIF
                       IF( med_diag%KW660%dgsave ) THEN
-                         f_kw6602d(ji,jj) = f_kw660
+                         f_kw6602d(ji,jj) = f_kw660(ji,jj)
                       ENDIF
                       IF( med_diag%ATM_PP0%dgsave ) THEN
-                         f_pp02d(ji,jj) = f_pp0
+                         f_pp02d(ji,jj) = f_pp0(ji,jj)
                       ENDIF
                       IF( med_diag%O2FLUX%dgsave ) THEN
-                         f_o2flux2d(ji,jj) = f_o2flux
+                         f_o2flux2d(ji,jj) = f_o2flux(ji,jj)
                       ENDIF
                       IF( med_diag%O2SAT%dgsave ) THEN
-                         f_o2sat2d(ji,jj) = f_o2sat
+                         f_o2sat2d(ji,jj) = f_o2sat(ji,jj)
                       ENDIF
                       !! AXY (24/11/16): add in extra MOCSY diagnostics
@@ -1933,26 +1909,26 @@
                       ENDIF
                       IF( med_diag%OCN_FCO2%dgsave ) THEN
-                         f_fco2w_2d(ji,jj) = f_fco2w
+                         f_fco2w_2d(ji,jj) = f_fco2w(ji,jj)
                       ENDIF
                       IF( med_diag%ATM_FCO2%dgsave ) THEN
-                         f_fco2a_2d(ji,jj) = f_fco2atm
+                         f_fco2a_2d(ji,jj) = f_fco2atm(ji,jj)
                       ENDIF
                       IF( med_diag%OCN_RHOSW%dgsave ) THEN
-                         f_ocnrhosw_2d(ji,jj) = f_rhosw
+                         f_ocnrhosw_2d(ji,jj) = f_rhosw(ji,jj)
                       ENDIF
                       IF( med_diag%OCN_SCHCO2%dgsave ) THEN
-                         f_ocnschco2_2d(ji,jj) = f_schmidtco2
+                         f_ocnschco2_2d(ji,jj) = f_schmidtco2(ji,jj)
                       ENDIF
                       IF( med_diag%OCN_KWCO2%dgsave ) THEN
-                         f_ocnkwco2_2d(ji,jj) = f_kwco2
+                         f_ocnkwco2_2d(ji,jj) = f_kwco2(ji,jj)
                       ENDIF
                       IF( med_diag%OCN_K0%dgsave ) THEN
-                         f_ocnk0_2d(ji,jj) = f_K0
+                         f_ocnk0_2d(ji,jj) = f_K0(ji,jj)
                       ENDIF
                       IF( med_diag%CO2STARAIR%dgsave ) THEN
-                         f_co2starair_2d(ji,jj) = f_co2starair
+                         f_co2starair_2d(ji,jj) = f_co2starair(ji,jj)
                       ENDIF
                       IF( med_diag%OCN_DPCO2%dgsave ) THEN
-                         f_ocndpco2_2d(ji,jj) = f_dpco2
+                         f_ocndpco2_2d(ji,jj) = f_dpco2(ji,jj)
                       ENDIF
                   ENDIF
@@ -1963,5 +1939,5 @@
                !! AXY (11/11/16): CMIP6 oxygen saturation 3D diagnostic
                IF ( med_diag%O2SAT3%dgsave ) THEN
-                  call oxy_sato( ztmp, zsal, f_o2sat3 )
+                  call oxy_sato( ztmp(ji,jj), zsal(ji,jj), f_o2sat3 )
                   o2sat3(ji, jj, jk) = f_o2sat3
                ENDIF
@@ -2049,19 +2025,19 @@
                !!
                !! non-diatoms
-	       if (zphn.GT.rsmall) then
-                  fthetan = max(tiny(zchn), (zchn * xxi) / (zphn + tiny(zphn)))
-                  faln    = xaln * fthetan
+	       if (zphn(ji,jj).GT.rsmall) then
+                  fthetan(ji,jj) = max(tiny(zchn(ji,jj)), (zchn(ji,jj) * xxi) / (zphn(ji,jj) + tiny(zphn(ji,jj))))
+                  faln(ji,jj)    = xaln * fthetan(ji,jj)
                else
-                  fthetan = 0.
-                  faln    = 0.
+                  fthetan(ji,jj) = 0.
+                  faln(ji,jj)    = 0.
                endif
                !!
                !! diatoms
-	       if (zphd.GT.rsmall) then
-                  fthetad = max(tiny(zchd), (zchd * xxi) / (zphd + tiny(zphd)))
-                  fald    = xald * fthetad
+	       if (zphd(ji,jj).GT.rsmall) then
+                  fthetad(ji,jj) = max(tiny(zchd(ji,jj)), (zchd(ji,jj) * xxi) / (zphd(ji,jj) + tiny(zphd(ji,jj))))
+                  fald(ji,jj)    = xald * fthetad(ji,jj)
                else
-                  fthetad = 0.
-                  fald    = 0.
+                  fthetad(ji,jj) = 0.
+                  fald(ji,jj)    = 0.
                endif
 
@@ -2070,6 +2046,6 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'faln(',jk,') = ', faln
-                  IF (lwp) write (numout,*) 'fald(',jk,') = ', fald
+                  IF (lwp) write (numout,*) 'faln(',jk,') = ', faln(ji,jj)
+                  IF (lwp) write (numout,*) 'fald(',jk,') = ', fald(ji,jj)
                endif
 # endif
@@ -2092,40 +2068,39 @@
                !! AXY (16/07/09)
                !! temperature for new Eppley style phytoplankton growth
-               loc_T   = tsn(ji,jj,jk,jp_tem)
-               fun_T   = 1.066**(1.0 * loc_T)
+               fun_T(ji,jj)   = 1.066**(1.0 * tsn(ji,jj,jk,jp_tem))
                !! AXY (16/05/11): add in new Q10 (1.5, not 2.0) for
                !phytoplankton
                !!                 growth; remin. unaffected
-               fun_Q10 = jq10**((loc_T - 0.0) / 10.0)
+               fun_Q10(ji,jj) = jq10**((tsn(ji,jj,jk,jp_tem) - 0.0) / 10.0)
                if (jphy.eq.1) then
-                  xvpnT = xvpn * fun_T
-                  xvpdT = xvpd * fun_T
+                  xvpnT(ji,jj) = xvpn * fun_T(ji,jj)
+                  xvpdT(ji,jj) = xvpd * fun_T(ji,jj)
                elseif (jphy.eq.2) then
-                  xvpnT = xvpn * fun_Q10
-                  xvpdT = xvpd * fun_Q10
+                  xvpnT(ji,jj) = xvpn * fun_Q10(ji,jj)
+                  xvpdT(ji,jj) = xvpd * fun_Q10(ji,jj)
                else
-                  xvpnT = xvpn
-                  xvpdT = xvpd
+                  xvpnT(ji,jj) = xvpn
+                  xvpdT(ji,jj) = xvpd
                endif
                !!
                !! non-diatoms
-               fchn1   = (xvpnT * xvpnT) + (faln * faln * xpar(ji,jj,jk) * xpar(ji,jj,jk))
-               if (fchn1.GT.rsmall) then
-                  fchn    = xvpnT / (sqrt(fchn1) + tiny(fchn1))
+               fchn1(ji,jj)   = (xvpnT(ji,jj) * xvpnT(ji,jj)) + (faln(ji,jj) * faln(ji,jj) * xpar(ji,jj,jk) * xpar(ji,jj,jk))
+               if (fchn1(ji,jj).GT.rsmall) then
+                  fchn(ji,jj)    = xvpnT(ji,jj) / (sqrt(fchn1(ji,jj)) + tiny(fchn1(ji,jj)))
                else
-                  fchn    = 0.
+                  fchn(ji,jj)    = 0.
                endif
-               fjln    = fchn * faln * xpar(ji,jj,jk) !! non-diatom J term
-               fjlim_pn = fjln / xvpnT
+               fjln(ji,jj)    = fchn(ji,jj) * faln(ji,jj) * xpar(ji,jj,jk) !! non-diatom J term
+               fjlim_pn(ji,jj) = fjln(ji,jj) / xvpnT(ji,jj)
                !!
                !! diatoms
-               fchd1   = (xvpdT * xvpdT) + (fald * fald * xpar(ji,jj,jk) * xpar(ji,jj,jk))
-               if (fchd1.GT.rsmall) then
-                  fchd    = xvpdT / (sqrt(fchd1) + tiny(fchd1))
+               fchd1(ji,jj)   = (xvpdT(ji,jj) * xvpdT(ji,jj)) + (fald(ji,jj) * fald(ji,jj) * xpar(ji,jj,jk) * xpar(ji,jj,jk))
+               if (fchd1(ji,jj).GT.rsmall) then
+                  fchd(ji,jj)    = xvpdT(ji,jj) / (sqrt(fchd1(ji,jj)) + tiny(fchd1(ji,jj)))
                else
-                  fchd    = 0.
+                  fchd(ji,jj)    = 0.
                endif
-               fjld    = fchd * fald * xpar(ji,jj,jk) !! diatom J term
-               fjlim_pd = fjld / xvpdT
+               fjld(ji,jj)    = fchd(ji,jj) * fald(ji,jj) * xpar(ji,jj,jk) !! diatom J term
+               fjlim_pd(ji,jj) = fjld(ji,jj) / xvpdT(ji,jj)
       
 # if defined key_debug_medusa
@@ -2133,8 +2108,8 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fchn(',jk,') = ', fchn
-                  IF (lwp) write (numout,*) 'fchd(',jk,') = ', fchd
-                  IF (lwp) write (numout,*) 'fjln(',jk,') = ', fjln
-                  IF (lwp) write (numout,*) 'fjld(',jk,') = ', fjld
+                  IF (lwp) write (numout,*) 'fchn(',jk,') = ', fchn(ji,jj)
+                  IF (lwp) write (numout,*) 'fchd(',jk,') = ', fchd(ji,jj)
+                  IF (lwp) write (numout,*) 'fjln(',jk,') = ', fjln(ji,jj)
+                  IF (lwp) write (numout,*) 'fjld(',jk,') = ', fjld(ji,jj)
                endif
 # endif
@@ -2145,11 +2120,11 @@
                !!
                !! non-diatoms (N, Fe)
-               fnln = zdin / (zdin + xnln) !! non-diatom Qn term
-               ffln = zfer / (zfer + xfln) !! non-diatom Qf term
+               fnln(ji,jj) = zdin(ji,jj) / (zdin(ji,jj) + xnln) !! non-diatom Qn term
+               ffln(ji,jj) = zfer(ji,jj) / (zfer(ji,jj) + xfln) !! non-diatom Qf term
                !!
                !! diatoms (N, Si, Fe)
-               fnld = zdin / (zdin + xnld) !! diatom Qn term
-               fsld = zsil / (zsil + xsld) !! diatom Qs term
-               ffld = zfer / (zfer + xfld) !! diatom Qf term
+               fnld(ji,jj) = zdin(ji,jj) / (zdin(ji,jj) + xnld) !! diatom Qn term
+               fsld(ji,jj) = zsil(ji,jj) / (zsil(ji,jj) + xsld) !! diatom Qs term
+               ffld(ji,jj) = zfer(ji,jj) / (zfer(ji,jj) + xfld) !! diatom Qf term
 
 # if defined key_debug_medusa
@@ -2157,9 +2132,9 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fnln(',jk,') = ', fnln
-                  IF (lwp) write (numout,*) 'fnld(',jk,') = ', fnld
-                  IF (lwp) write (numout,*) 'ffln(',jk,') = ', ffln
-                  IF (lwp) write (numout,*) 'ffld(',jk,') = ', ffld
-                  IF (lwp) write (numout,*) 'fsld(',jk,') = ', fsld
+                  IF (lwp) write (numout,*) 'fnln(',jk,') = ', fnln(ji,jj)
+                  IF (lwp) write (numout,*) 'fnld(',jk,') = ', fnld(ji,jj)
+                  IF (lwp) write (numout,*) 'ffln(',jk,') = ', ffln(ji,jj)
+                  IF (lwp) write (numout,*) 'ffld(',jk,') = ', ffld(ji,jj)
+                  IF (lwp) write (numout,*) 'fsld(',jk,') = ', fsld(ji,jj)
                endif
 # endif
@@ -2172,10 +2147,10 @@
                if (jliebig .eq. 0) then
                   !! multiplicative nutrient limitation
-                  fpnlim = fnln * ffln
+                  fpnlim(ji,jj) = fnln(ji,jj) * ffln(ji,jj)
                elseif (jliebig .eq. 1) then
                   !! Liebig Law (= most limiting) nutrient limitation
-                  fpnlim = min(fnln, ffln)
+                  fpnlim(ji,jj) = min(fnln(ji,jj), ffln(ji,jj))
                endif
-               fprn = fjln * fpnlim
+               fprn(ji,jj) = fjln(ji,jj) * fpnlim(ji,jj)
 
                !!----------------------------------------------------------------------
@@ -2191,18 +2166,18 @@
                if (jliebig .eq. 0) then
                   !! multiplicative nutrient limitation
-                  fpdlim = fnld * ffld
+                  fpdlim(ji,jj) = fnld(ji,jj) * ffld(ji,jj)
                elseif (jliebig .eq. 1) then
                   !! Liebig Law (= most limiting) nutrient limitation
-                  fpdlim = min(fnld, ffld)
+                  fpdlim(ji,jj) = min(fnld(ji,jj), ffld(ji,jj))
                endif
                !!
-	       if (zphd.GT.rsmall .AND. zpds.GT.rsmall) then
+	       if (zphd(ji,jj).GT.rsmall .AND. zpds(ji,jj).GT.rsmall) then
                   !! "intracellular" elemental ratios
-                  ! fsin  = zpds / (zphd + tiny(zphd))
-                  ! fnsi  = zphd / (zpds + tiny(zpds))
-                  fsin = 0.0
-                  IF( zphd .GT. rsmall) fsin  = zpds / zphd
-                  fnsi = 0.0
-                  IF( zpds .GT. rsmall) fnsi  = zphd / zpds
+                  ! fsin(ji,jj)  = zpds(ji,jj) / (zphd(ji,jj) + tiny(zphd(ji,jj)))
+                  ! fnsi(ji,jj)  = zphd(ji,jj) / (zpds(ji,jj) + tiny(zpds(ji,jj)))
+                  fsin(ji,jj) = 0.0
+                  IF( zphd(ji,jj) .GT. rsmall) fsin(ji,jj)  = zpds(ji,jj) / zphd(ji,jj)
+                  fnsi(ji,jj) = 0.0
+                  IF( zpds(ji,jj) .GT. rsmall) fnsi(ji,jj)  = zphd(ji,jj) / zpds(ji,jj)
                   !! AXY (23/02/10): these next variables derive from Mongin et al. (2003)
                   fsin1 = 3.0 * xsin0 !! = 0.6
@@ -2212,29 +2187,29 @@
                   !! conditionalities based on ratios
                   !! nitrogen (and iron and carbon)
-                  if (fsin.le.xsin0) then
-                     fprd  = 0.0
-                     fsld2 = 0.0
-                  elseif (fsin.lt.fsin1) then
-                     fprd  = xuif * ((fsin - xsin0) / (fsin + tiny(fsin))) * (fjld * fpdlim)
-                     fsld2 = xuif * ((fsin - xsin0) / (fsin + tiny(fsin)))
-                  elseif (fsin.ge.fsin1) then
-                     fprd  = (fjld * fpdlim)
-                     fsld2 = 1.0
+                  if (fsin(ji,jj).le.xsin0) then
+                     fprd(ji,jj)  = 0.0
+                     fsld2(ji,jj) = 0.0
+                  elseif (fsin(ji,jj).lt.fsin1) then
+                     fprd(ji,jj)  = xuif * ((fsin(ji,jj) - xsin0) / (fsin(ji,jj) + tiny(fsin(ji,jj)))) * (fjld(ji,jj) * fpdlim(ji,jj))
+                     fsld2(ji,jj) = xuif * ((fsin(ji,jj) - xsin0) / (fsin(ji,jj) + tiny(fsin(ji,jj))))
+                  elseif (fsin(ji,jj).ge.fsin1) then
+                     fprd(ji,jj)  = (fjld(ji,jj) * fpdlim(ji,jj))
+                     fsld2(ji,jj) = 1.0
                   endif
                   !!
                   !! silicon
-                  if (fsin.lt.fnsi1) then
-                     fprds = (fjld * fsld)
-                  elseif (fsin.lt.fnsi2) then
-                     fprds = xuif * ((fnsi - xnsi0) / (fnsi + tiny(fnsi))) * (fjld * fsld)
+                  if (fsin(ji,jj).lt.fnsi1) then
+                     fprds(ji,jj) = (fjld(ji,jj) * fsld(ji,jj))
+                  elseif (fsin(ji,jj).lt.fnsi2) then
+                     fprds(ji,jj) = xuif * ((fnsi(ji,jj) - xnsi0) / (fnsi(ji,jj) + tiny(fnsi(ji,jj)))) * (fjld(ji,jj) * fsld(ji,jj))
                   else
-                     fprds = 0.0
+                     fprds(ji,jj) = 0.0
                   endif     
                else
-                  fsin  = 0.0
-                  fnsi  = 0.0
-                  fprd  = 0.0
-                  fsld2 = 0.0
-                  fprds = 0.0
+                  fsin(ji,jj)  = 0.0
+                  fnsi(ji,jj)  = 0.0
+                  fprd(ji,jj)  = 0.0
+                  fsld2(ji,jj) = 0.0
+                  fprds(ji,jj) = 0.0
                endif
 
@@ -2243,10 +2218,10 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fsin(',jk,')   = ', fsin
-                  IF (lwp) write (numout,*) 'fnsi(',jk,')   = ', fnsi
-                  IF (lwp) write (numout,*) 'fsld2(',jk,')  = ', fsld2
-                  IF (lwp) write (numout,*) 'fprn(',jk,')   = ', fprn
-                  IF (lwp) write (numout,*) 'fprd(',jk,')   = ', fprd
-                  IF (lwp) write (numout,*) 'fprds(',jk,')  = ', fprds
+                  IF (lwp) write (numout,*) 'fsin(',jk,')   = ', fsin(ji,jj)
+                  IF (lwp) write (numout,*) 'fnsi(',jk,')   = ', fnsi(ji,jj)
+                  IF (lwp) write (numout,*) 'fsld2(',jk,')  = ', fsld2(ji,jj)
+                  IF (lwp) write (numout,*) 'fprn(',jk,')   = ', fprn(ji,jj)
+                  IF (lwp) write (numout,*) 'fprd(',jk,')   = ', fprd(ji,jj)
+                  IF (lwp) write (numout,*) 'fprds(',jk,')  = ', fprds(ji,jj)
                endif
 # endif
